/*
 * Chip
 *
 * Index
 * - Outline
 * - Icon
 * - Close
 * - Size
 * - Color
 */

:host {
  box-sizing: border-box;
  display: inline-flex;
  align-items: center;
  height: 1.5rem;
  padding: 0.25rem 0.5rem;
  margin-bottom: 0.5rem;
  font-size: var(--road-font-size-14);
  cursor: pointer;
  border: 0;
  border-radius: 1.625rem;
  outline: 0;
  transition: background 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms, border 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
}

.chip-description {
  display: inline-flex;
  align-items: center;
  padding: 0 0.5rem;
}

/* OUTLINE
 -------------------- */

:host(.chip-outline) {
  border-style: solid;
  border-width: 1px;
}

/* ICON
 -------------------- */

::slotted(road-icon) {
  width: 1.25rem;
  height: 1.25rem;
  margin-right: 0.5rem;
  margin-left: -0.5rem;
}

/* CLOSE
 -------------------- */

.chip-close {
  width: 1rem;
  height: 1rem;
  margin-right: -0.25rem;
  color: var(--road-surface);
  background: var(--road-on-surface-weak);
  border-radius: 50%;
  transition: background 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
}

:host(.chip-outline.chip-inverse) .chip-close {
  color: var(--road-icon);
  background: var(--road-surface);
}


/* SIZE
 -------------------- */

:host(.chip-lg) {
  height: 2.5rem;
  padding: 0 0.75rem;
  font-size: var(--road-font-size-16);
}

:host(.chip-lg) ::slotted(road-icon) {
  width: 1.5rem;
  height: 1.5rem;
  margin-right: 0.75rem;
  margin-left: -0.75rem;
}

:host(.chip-lg) .chip-description {
  padding: 0 0.75rem;
}

:host(.chip-lg) .chip-close {
  width: 1.5rem;
  height: 1.5rem;
}

/* COLOR
 -------------------- */

:host(.chip-default) {
  color: var(--road-on-surface);
  background: var(--road-grey-200);
}

:host(.chip-inverse) {
  color: var(--road-on-primary);
  background: none;
}

:host(.chip-outline.chip-default) {
  background: var(--road-surface);
  border-color: var(--road-input-outline);
}

:host(.chip-outline.chip-inverse) {
  border-color: var(--road-on-primary);
}

:host(.chip-secondary) {
  color: var(--road-on-button-primary);
  background: var(--road-button-primary);
  border-color: transparent;
}

:host(.chip-secondary) .chip-close {
  color: var(--road-primary);
  background: var(--road-surface);
}

/**
 * Hover state
 */

@media (any-hover: hover) {

  :host(.chip-outline:hover) {
    border-color: var(--road-outline-variant);
  }

  :host(.chip-secondary:hover) {
    background: var(--road-button-primary-variant);
  }

  :host(.chip-secondary:hover) .chip-close {
    color: var(--road-primary);
  }
}

/**
 * Focus state
 */

:host(.chip-outline:focus-visible) {
  border-color: var(--road-outline-variant);
  outline: auto;
}

:host(.chip-secondary.focus-visible) {
  background: var(--road-button-primary-variant);
  outline: auto;
}
